// -*- mode: c++ -*-
// 
// File MDF.C generated by TMultiDimFit::MakeRealCode
// on Fri Apr  1 23:19:42 2005
// ROOT version 4.03/03
//
// This file contains the function 
//
//    double  MDF(double *x); 
//
// For evaluating the parameterization obtained
// from TMultiDimFit and the point x
// 
// See TMultiDimFit class documentation for more information 
// 
//
// Static data variables
//
static int    gNVariables    = 4;
static int    gNCoefficients = 22;
static double gDMean         = 45.8383;
// Assignment to mean vector.
static double gXMean[] = {
  -0.0361681, 0.0063121, -0.00773313, 0.023277 };

// Assignment to minimum vector.
static double gXMin[] = {
  0.000501871, 0.00257969, 0.037837, 0.0216842 };

// Assignment to maximum vector.
static double gXMax[] = {
  9.95356, 9.99543, 9.99466, 9.95317 };

// Assignment to coefficients vector.
static double gCoefficient[] = {
  -2.57988,
  43.2694,
  13.2747,
  13.4143,
  13.3844,
  13.4842,
  13.3206,
  13.3148,
  4.4177,
  -3.93429,
  4.60247,
  -4.07129,
  -3.99255,
  4.51781,
  3.45324,
  -4.15551,
  4.75041,
  4.28688,
  -3.85046,
  -4.0053,
  4.3955,
  3.59419
 };

// Assignment to powers vector.
// The powers are stored row-wise, that is
//  p_ij = gPower[i * NVariables + j];
static int    gPower[] = {
  1,  1,  1,  1,
  2,  1,  1,  1,
  1,  1,  1,  2,
  1,  1,  2,  1,
  1,  2,  1,  1,
  2,  2,  1,  1,
  2,  1,  1,  2,
  2,  1,  2,  1,
  1,  1,  1,  3,
  1,  2,  1,  2,
  1,  1,  3,  1,
  1,  2,  2,  1,
  1,  1,  2,  2,
  1,  3,  1,  1,
  1,  2,  2,  2,
  2,  2,  1,  2,
  2,  1,  3,  1,
  2,  1,  1,  3,
  2,  1,  2,  2,
  2,  2,  2,  1,
  2,  3,  1,  1,
  2,  2,  2,  2
};

// 
// The function   double MDF(double *x)
// 
double MDF(double *x) {
  double returnValue = gDMean;
  int    i = 0, j = 0, k = 0;
  for (i = 0; i < gNCoefficients ; i++) {
    // Evaluate the ith term in the expansion
    double term = gCoefficient[i];
    for (j = 0; j < gNVariables; j++) {
      // Evaluate the polynomial in the jth variable.
      int power = gPower[gNVariables * i + j]; 
      double p1 = 1, p2 = 0, p3 = 0, r = 0;
      double v =  1 + 2. / (gXMax[j] - gXMin[j]) * (x[j] - gXMax[j]);
      // what is the power to use!
      switch(power) {
      case 1: r = 1; break; 
      case 2: r = v; break; 
      default: 
        p2 = v; 
        for (k = 3; k <= power; k++) { 
          p3 = p2 * v;
          p1 = p2; p2 = p3; 
        }
        r = p3;
      }
      // multiply this term by the poly in the jth var
      term *= r; 
    }
    // Add this term to the final result
    returnValue += term;
  }
  return returnValue;
}

// EOF for MDF.C
